"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * The base of a Monad
 */
var MonadBase = /** @class */ (function () {
    function MonadBase(value, log) {
        Object.defineProperty(this, "value", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "log", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.value = value;
        this.log = log;
    }
    Object.defineProperty(MonadBase.prototype, "apply", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (func) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            this.value = func.apply(void 0, __spreadArray([this.value], args, false));
            return this.finish();
        }
    });
    Object.defineProperty(MonadBase.prototype, "finish", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (skip) {
            if (skip === void 0) { skip = false; }
            if (!this.log || skip)
                return new MonadBase(this.value, this.log);
            return new MonadBase(this.value, __spreadArray(__spreadArray([], this.log, true), [this.value], false));
        }
    });
    Object.defineProperty(MonadBase.prototype, "promise", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (func) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return new PromisedMonad(this, [[func, args]]);
        }
    });
    Object.defineProperty(MonadBase, "all", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (promisedMonads) {
            return Promise.all(promisedMonads.map(function (monad) { return monad.resolve(); }));
        }
    });
    return MonadBase;
}());
/**
 * Maybe extension
 */
var Maybe = /** @class */ (function (_super) {
    __extends(Maybe, _super);
    function Maybe(value, log, before) {
        var _this = _super.call(this, value, log) || this;
        Object.defineProperty(_this, "before", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        _this.before = before;
        return _this;
    }
    Object.defineProperty(Maybe.prototype, "apply", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (func) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            if (this.value === null)
                return this;
            if (this.value === undefined)
                return this;
            if (this.before && !this.before(this.value))
                return this;
            var _a = _super.prototype.apply.apply(this, __spreadArray([func], args, false)), value = _a.value, log = _a.log;
            return new Maybe(value, log, this.before);
        }
    });
    return Maybe;
}(MonadBase));
/**
 * Either extension
 */
var Either = /** @class */ (function (_super) {
    __extends(Either, _super);
    function Either() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(Either.prototype, "apply", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (leftFunc, rightFunc) {
            var args = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                args[_i - 2] = arguments[_i];
            }
            try {
                var _a = _super.prototype.apply.apply(this, __spreadArray([rightFunc], args, false)), value = _a.value, log = _a.log;
                return new Either(value, log);
            }
            catch (_b) {
                var _c = _super.prototype.apply.apply(this, __spreadArray([leftFunc], args, false)), value = _c.value, log = _c.log;
                return new Either(value, log);
            }
        }
    });
    Object.defineProperty(Either.prototype, "fold", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (maybe) {
            if (maybe === void 0) { maybe = false; }
            if (maybe)
                return new Maybe(this.value, this.log);
            return new MonadBase(this.value, this.log);
        }
    });
    return Either;
}(MonadBase));
/**
 * Promise extension
 */
var PromisedMonad = /** @class */ (function (_super) {
    __extends(PromisedMonad, _super);
    function PromisedMonad(maybe, tasks) {
        var _this = _super.call(this, maybe.value, maybe.log) || this;
        Object.defineProperty(_this, "tasks", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        _this.tasks = tasks;
        return _this;
    }
    Object.defineProperty(PromisedMonad.prototype, "promise", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (func) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            this.tasks.push([func, args]);
            return this;
        }
    });
    Object.defineProperty(PromisedMonad.prototype, "resolve", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function () {
            var e_1, _a;
            var _b;
            return __awaiter(this, void 0, void 0, function () {
                var _c, _d, _e, func, args, _f, e_1_1;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            _g.trys.push([0, 6, 7, 12]);
                            _c = __asyncValues(this.tasks);
                            _g.label = 1;
                        case 1: return [4 /*yield*/, _c.next()];
                        case 2:
                            if (!(_d = _g.sent(), !_d.done)) return [3 /*break*/, 5];
                            _e = _d.value, func = _e[0], args = _e[1];
                            _f = this;
                            return [4 /*yield*/, func.apply(void 0, __spreadArray([this.value], args, false))];
                        case 3:
                            _f.value = _g.sent();
                            (_b = this.log) === null || _b === void 0 ? void 0 : _b.push(this.value);
                            _g.label = 4;
                        case 4: return [3 /*break*/, 1];
                        case 5: return [3 /*break*/, 12];
                        case 6:
                            e_1_1 = _g.sent();
                            e_1 = { error: e_1_1 };
                            return [3 /*break*/, 12];
                        case 7:
                            _g.trys.push([7, , 10, 11]);
                            if (!(_d && !_d.done && (_a = _c.return))) return [3 /*break*/, 9];
                            return [4 /*yield*/, _a.call(_c)];
                        case 8:
                            _g.sent();
                            _g.label = 9;
                        case 9: return [3 /*break*/, 11];
                        case 10:
                            if (e_1) throw e_1.error;
                            return [7 /*endfinally*/];
                        case 11: return [7 /*endfinally*/];
                        case 12: return [2 /*return*/, this.finish(true)];
                    }
                });
            });
        }
    });
    return PromisedMonad;
}(MonadBase));
var Monad = /** @class */ (function (_super) {
    __extends(Monad, _super);
    function Monad() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(Monad, "Maybe", {
        enumerable: true,
        configurable: true,
        writable: true,
        value: Maybe
    });
    Object.defineProperty(Monad, "Either", {
        enumerable: true,
        configurable: true,
        writable: true,
        value: Either
    });
    return Monad;
}(MonadBase));
exports.default = Monad;
//# sourceMappingURL=monad.js.map